#include "hostlist.h"

#include "host.h"
#include "botinfo.h"


//////// Host list ////////

hostList::hostList()
{
	maximumHosts = 0;
}

hostList::~hostList()
{
}

void hostList::doEvents()
{
	_listnode <Host> *parse = list.head;

	while (parse)
	{
		Host *h = parse->item;
		parse = parse->next;

		h->doEvents();

		if (h->killMe)
		{
			list.kill(h);
		}
	}
}

bool hostList::connectHost(BOT_INFO &botInfo)
{
	if (!findSpawn(botInfo.name))
	{
		Host *h = new Host(botInfo);
		if (h)
		{
			list.append(h);
			return true;
		}
	}

	return true;
}

void hostList::massDisconnect()
{
	_listnode <Host> *parse = list.head;

	while (parse)
	{
		Host *h = parse->item;
		parse = parse->next;

		h->disconnect(true);
	}
}

Uint32 hostList::getConnections()
{
	return list.total;
}

Host *hostList::findSpawn(char *name)
{
	_listnode <Host> *parse = list.head;

	while (parse)
	{
		Host *h = parse->item;
		parse = parse->next;

		if (CMPSTR(h->botInfo.name, name)) return h;
	}

	return NULL;
}
